/*Copyright 2006 Mathieu Lemire*/
#include<iostream>
#include<string>
#include<fstream>
#include<sstream>


#define L_LENGTH 1000000

#define DEBUG 0

// this reads in a pedigree structure and finds the parents of the individuals

using namespace std;

class Prefile
{

  string * pedigreeName;
  string * individualName;
  string * fatherName;
  string * motherName;
  int * sex;
  string * restOfLine;

  bool * hasDna;

  int nPedigrees;
  int * pedigreeBounds;
  int nIndividuals;
  int nColumns;

  bool * isFounder;
  int * motherIs;
  int * fatherIs;

public:

  Prefile(char * , bool, bool);

  ~Prefile(){
    delete [] pedigreeName;
    delete [] individualName;
    delete [] fatherName;
    delete [] motherName;
    delete [] sex;
    delete [] restOfLine;
    delete [] hasDna;
    delete [] pedigreeBounds;
    delete [] isFounder;
    delete [] motherIs;
    delete [] fatherIs;
  }


  void FindParents();
  
  string PedigreeName(int i){
    return pedigreeName[i];
  }
  string IndividualName(int i){
    return individualName[i];
  }
  string FatherName(int i){
    return fatherName[i];
  }
  string MotherName(int i){
    return motherName[i];
  }
  int Sex(int i){
    return sex[i];
  }
  string RestOfLine(int i){
    return restOfLine[i];
  }
  bool HasDNA (int i){
    return hasDna[i];
  }
  bool IsFounder(int i){
    return isFounder[i];
  }
  int MotherIs(int i){
    return motherIs[i];
  }
  int FatherIs(int i){
    return fatherIs[i];
  }
  int NIndividuals(){
    return nIndividuals;
  }
  int NPedigrees(){
    return nPedigrees;
  }
  int PedigreeBounds(int i){
    return pedigreeBounds[i];
  }
  int NColumns(){
    return nColumns;
  }



};


